Subject: getldentifierByObject for POP-Objects

Description

PersistenceManager::getldentifierByObject() currently returns NULL if you pass it a "non-entity", thus
PersistenceManager::convertObjectToldentityArray() throws an exception if the array contains such object.
This feature request suggests to make it possible to retrieve a unique id for arbitrary Plain Old PHP objects.

NOTE

I moved this issue from the Fluid tracker. It had the subject Usage of Session Scope Objects as arguments in f:link.action should
be possible but is rather an "issue" of the persistence.

I'm not convinced that such feature would make sense yet, but | wanted to get some more input before rejecting it.

Here the original description:

When trying to use a session scope object as argument in f:link.action viewhelper i get the following Error:

#1302628242: The given object is unknown to the Persistence Manager.

It sould be possible to use Session Scope Obejcts (or objects stored inside them) as arguments because they are persisted in session
scope.

Here is a example:
| have a ShopingBasket with scope=session with Basketltems stroed inside. Now i want to create a delete link for a Basketltem. This
is not possible without using a self implemented id at the moment.

History

#1 - 2012-12-20 12:22 - Bastian Waidelich

- Category set to ViewHelpers

- Status changed from New to Needs Feedback
- Assigned To set to Bastian Waidelich

Obijects that are not known to the Persistence Manager don't have an identifier. so how should we generate the link? Serializing the complete object is
not an option.

Instead, you should inject the basket to your controller and have a deleteltemAction or similar.

Or did | get you wrong?

#2 - 2012-12-20 12:31 - Benno Weinzierl

Objects that are not known to the Persistence Manager don't have an identifier. so how should we generate the link? Serializing the complete

object is not an option.
Yes, that's the problem. Why can't they have an identifier of some sort? They are persisted in the Session so there sould be an identifier?

Instead, you should inject the basket to your controller and have a deleteltemAction or similar.

Thats what i am trying to do. | have a deleteltemAction but i cannot send the item as an argument because it is persisted in the session and has

therefore no identifier.

Or did | get you wrong?

#3 - 2012-12-20 12:46 - Bastian Waidelich

Benno Weinzierl wrote:

Objects that are not known to the Persistence Manager don't have an identifier. so how should we generate the link? Serializing the complete

object is not an option.

Yes, that's the problem. Why can't they have an identifier of some sort? They are persisted in the Session so there sould be an identifier?

The scope "session" is a specialization of "singleton”. It is meant for object instances to exist exactly once in the current session — like a shopping

basket.

So there is no need to pass the object around, as well as there is no reason to pass around singletons — because you can always inject the object.

Instead, you should inject the basket to your controller and have a deleteltemAction or similar.

Thats what i am trying to do. | have a deleteltemAction but i cannot send the item as an argument because it is persisted in the session and has

therefore no identifier.

Well, the item in your basket should have some relation to a persistent entity (e.g. product) don't they?

Maybe https://github.com/robertlemke/RoeBooks.Shop helps you (even though it's a bit outdated in the meantime).

Or how does an item in your basket look like?

#4 - 2012-12-20 15:00 - Benno Weinzierl

Bastian Waidelich wrote:

Benno Weinzierl wrote:

Objects that are not known to the Persistence Manager don't have an identifier. so how should we generate the link? Serializing the complete
object is not an option.

Yes, that's the problem. Why can't they have an identifier of some sort? They are persisted in the Session so there sould be an identifier?

The scope "session" is a specialization of "singleton”. It is meant for object instances to exist exactly once in the current session — like a shopping
basket.

So there is no need to pass the object around, as well as there is no reason to pass around singletons — because you can always inject the object.

You got a point there for session objects. But what about any other prototype object possibly stroed inside a session scope object or maybe even a
arbitrary prototype which i want to pass to the next controller. Would it not be great to just use any prototype object as argument?

Or at least if it is already stored in a sessionscope object? Likle my Basketltem?

Instead, you should inject the basket to your controller and have a deleteltemAction or similar.

Thats what i am trying to do. | have a deleteltemAction but i cannot send the item as an argument because it is persisted in the session and has
therefore no identifier.

Well, the item in your basket should have some relation to a persistent entity (e.g. product) don't they?
Maybe https.//qithub.com/robertlemke/RoeBooks.Shop helps you (even though it's a bit outdated in the meantime).

Or how does an item in your basket look like?

In my case the Basketltem hat property quantity, product but also configuration of the product. So in my case it is possible to put more than one
basketltem with the same product in the basket. The only solution for my problem at the moment is to generate my own unique id for each item and
sumbit that which is not realy flow-style.

#5 - 2012-12-21 11:15 - Bastian Waidelich
- Project changed from TYPOGS.Fluid to TYPO3.Flow
- Category deleted (ViewHelpers)

#6 - 2012-12-21 11:30 - Bastian Waidelich

- Subject changed from Usage of Session Scope Objects as arguments in f:link.action should be possible to getldentifierByObject for POP-Objects
- Category set to Persistence

- Assigned To deleted (Bastian Waidelich)

- Priority changed from Should have to -- undefined --

Hi,

| moved this issue to the Flow tracker in order to get some more feedback, but | doubt that we should include such functionality to the core.

In my case the Basketltem hat property quantity, product but also configuration of the product.

You could simply pass the item index like:

1<f:for each="{basket.items}" as="item" iteration="iteration">
2 <filink.action action="removeltem" arguments="{itemindex: iteration.index}">Remove {item.title}</f:link.action>
3</f:for>

Of course the index is ambiguous in this case — if you open the link twice it might remove two items from the basket. If that's an issue you can easily
give the item it's own id (e.g. via \TYPO3\Flow\Utility\Algorithms::generateUUID()) and use it like:

1<f:for each="{basket.items}" as="item">

2 <filink.action action="removeltem" arguments="{itemld: item.id}">Remove {item.title}</f:link.action>
3</f:for>
HTH

#7 - 2013-08-14 16:08 - Karsten Dambekalns
- Status changed from Needs Feedback to Closed
- Assigned To set to Bastian Waidelich
